<!-- This example requires Tailwind CSS v2.0+ -->
<template>
  <header
    class="bg-gray-200 mt-20 mb-20 rounded-md space-y-4 p-4 sm:px-8 sm:py-6 lg:p-4 xl:px-8 xl:py-6"
  >
    <div class="flex items-center justify-start">
      <button
        class="h-10 text-center inline-flex items-center px-6 font-semibold rounded-full bg-[#549DF2] text-white"
        type="button"
        @click="goToHomePage"
      >
        <svg
          aria-hidden="true"
          class="mr-2 ml-1 w-5 h-5"
          fill="currentColor"
          viewBox="0 0 448 512"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M257.5 445.1l-22.2 22.2c-9.4 9.4-24.6 9.4-33.9 0L7 273c-9.4-9.4-9.4-24.6 0-33.9L201.4 44.7c9.4-9.4 24.6-9.4 33.9 0l22.2 22.2c9.5 9.5 9.3 25-.4 34.3L136.6 216H424c13.3 0 24 10.7 24 24v32c0 13.3-10.7 24-24 24H136.6l120.5 114.8c9.8 9.3 10 24.8.4 34.3z"
          ></path>
        </svg>

        Back
      </button>
      <div class="flex space-x-4 ml-20 items-center">
        <div>
          <h1 class="text-lg font-bold">
            {{ details.title }}
          </h1>
          <h2 class="mt-2">
            {{ details.tagline }}
          </h2>
        </div>
      </div>
    </div>
  </header>
  <div class="flex rounded-lg w-auto">
    <div class="w-1/3 rounded-lg">
      <img
        v-if="!details.poster_path"
        src="../../assets/blank_poster.png"
        alt=""
        class="inset-0 w-[330px] h-auto object-cover rounded-lg contrast-50"
        loading="lazy"
      />
      <img
        :src="posterBaseUrl + details.poster_path"
        alt=""
        class="inset-0 w-[330px] h-auto object-cover rounded-lg"
        loading="lazy"
      />
    </div>
    <form class="flex-auto w-2/3 p-4 pl-10">
      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Budget</h1>
        </div>
        <div>
          <h1 v-if="details.budget >= 0" class="">
            ${{ formatnumber(details.budget) }}
          </h1>
          <div v-else>
            -
          </div>
        </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Revenue</h1>
        </div>
        <div>
          <h1 v-if="details.revenue >= 0" class="">
            ${{ formatnumber(details.revenue) }}
          </h1>
          <div v-else>
            -
          </div>
        </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Release Date</h1>
        </div>
        <div>
          <h1 v-if="details.release_date">
            {{ details.release_date }}
          </h1>
          <div v-else>
            -
          </div>
        </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Runtime</h1>
        </div>
        <div v-if="details.runtime">
          <h1 class="">
            {{ convertRuntime }}
          </h1>
        </div>
        <div v-else>
            -
          </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Score</h1>
        </div>
        <div v-if="details.vote_average">
          <stars-rating
            :totalStars="10"
            :isIndicatorActive="true"
            :starStyle="starStyle"
            :rating="details.vote_average"
          ></stars-rating>
          <span class="movie-smal-font"> ({{ details.vote_count }} votes) </span>
        </div>
        <div v-else>
            -
          </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Genres</h1>
        </div>
        <div>
          <h1 class="">
            <div v-if="details?.genres?.length > 0" class="w-full">
              <template v-for="(genere, index) in details?.genres" :key="index">
                <span
                  class="ml-1 mr-1"
                  v-if="index > 0 && index < details.genres.length"
                  >,</span
                >
                {{ genere.name }}
              </template>
            </div>
            <div v-else>
            -
          </div>
          </h1>
        </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">IMDB Link</h1>
        </div>
        <div>
          <a v-if="details.imdb_id" class="text-blue-600 " target="_blank" :href="`https://www.imdb.com/title/${details.imdb_id}`">
            Link
          </a>
          <div v-else>
            -
          </div>
        </div>
      </div>

      <div class="flex items-center justify-between mb-5">
        <div>
          <h1 class="movie-title">Homepage Link</h1>
        </div>
        <div>
          <a v-if="details.homepage" class="text-blue-600" target="_blank" :href="details.homepage">
            Link
          </a>
           <div v-else>
            -
          </div>
        </div>
      </div>
    </form>
  </div>

  <div class="flex mt-10 text-base font-sans p-3">
    <span class="">
      {{ details.overview }}
    </span>
  </div>
  <div class="mt-10 font-sans mb-20 pb-20">
    <h1 class="font-semibold text-lg mb-2">Credit</h1>

    <div v-if="sortedCredites.length>0" class="w-full text-sm">
      <template v-for="(cast, index) in sortedCredites" :key="index">
        <template v-if="index < 10">
          <span
            class="ml-1 mr-1"
            v-if="index > 0 && index < sortedCredites.length"
            >,</span
          >
          {{ cast.name }}
        </template>
      </template>
      <span v-if="sortedCredites.length > 10">
        and {{ sortedCredites.length - 10 }} more</span
      >
    </div>
    <div v-else>
            -
          </div>
  </div>
</template>

<script>
import MovieDataService from "../../services/MovieDataService";
import starsRating from "../rating-star.vue";
export default {
  components: { starsRating },

  data() {
    return {
      starStyle: {
        fullStarColor: "#ed8a19",
        emptyStarColor: "#737373",
        starWidth: 15,
        starHeight: 15,
      },

      rating: 5,
      details: [],
      credites: [],
      sortedCredites: [],
      posterBaseUrl: "https://image.tmdb.org/t/p/w500",
    };
  },
  methods: {
    async retrieveMovieDetails(movie_id) {
      this.$store.commit("setLoadingStatus", true);

      await MovieDataService.getMovieDetails(movie_id)
        .then((response) => {
          this.details = response.data;
          this.$store.commit("setLoadingStatus", false);

        })
        .catch((e) => {
          this.$store.commit("setLoadingStatus", false);
          this.$swal.fire({
            icon: "error",
            title: "Oops...",
            text: e.message,
          });
          console.log(e);
        });
    },
    retrieveMovieCredites(movie_id) {
      MovieDataService.getMovieCredites(movie_id)
        .then((response) => {
          this.credites = response.data.cast;
          this.sortedCredites = this.credites.sort(function (a, b) {
            return b.popularity - a.popularity;
          });
        })
        .catch((e) => {
          console.log(e);
        });
    },
    formatnumber(newValue) {
      if (newValue == 0) {
        return `0`;
      } else {
        var result = newValue.toString().replace(/\B(?=(\d{3})+(?!\d))/g, "'");
        return result;
      }
    },
    goToHomePage() {
      this.$router.push({ name: "list-of-movies" });
    },
  },
  computed: {
    convertRuntime() {
      return (
        Math.floor(this.details?.runtime / 60) +
        "hr " +
        (this.details?.runtime % 60) +
        "m"
      );
    },
  },
  mounted() {
    this.retrieveMovieDetails(this.$route.params.movie_id);
    this.retrieveMovieCredites(this.$route.params.movie_id);
  },
};
</script>
